#define UNICODE
#include "windows.inc"
#include "shlwapi.inc"

#define SHORT_NAME L"Event Log Notifier"

struct REGVALUE
{
	REGVALUE *next;
	REGVALUE *older;
	void     *owner; // REGKEY*
	LPWSTR pwszName;
	DWORD  dwType;
	DWORD  nDataLen;
	LPVOID pData;
	BOOL   IsNew;
	// WCHAR name[]
	// WCHAR data[]
}

struct REGKEY
{
	REGKEY   *next;
	REGKEY   *childs;
	REGKEY   *parent;
	REGKEY   *deletedchilds;
	LPWSTR    pwszName;       // may be NULL for root keys
	REGVALUE *values;
	REGVALUE *deletedvalues;
	FILETIME  LastWriteTime;
	DWORD     dwFlags;        // REGKEYFLAG
	// WCHAR name[]
}
const REGKEYFLAG_ISNEW = 1;
const REGKEYFLAG_INCLUDE_SUBTREE = 2;
const REGKEYFLAG_INCLUDE_VALUES  = 4;
const REGKEYFLAG_INCLUDE_SUBKEYS = 8;

//#define SAVE_CHANGED_VALUES // REGVALUE.older
//#define SAVE_DELETED_VALUES // REGKEY.deletedvalues
//#define SAVE_DELETED_KEYS   // REGKEY.deletedchilds

#define REGISTRYLOGHEADER     L"NodeSize: %.7d %.4d.%.2d.%.2d %.2d:%.2d:%.2d\n"
//                              NodeSize: 1234567 yyyy:mm:dd hh:mm:ss\n
#define REGISTRYLOGHEADERSIZE 78
#define OFFSETTODATASIZEVALUE 10 // %.7d

#define REGISTRYLOGHEADER2     L"\n"
#define REGISTRYLOGHEADER2SIZE 4

#define VERSION2
struct MODULENODE
{
	MODULENODE *next;
	dwstring wszPath[1];
}

struct EVENTDATA
{
	MODULENODE *pMessageFiles;
	MODULENODE *pParameterMessageFiles;
}

class Unknown
{
	declare Unknown();
	declare virtual QueryInterface(REFIID *riid, void *ppvObject),HRESULT;
	declare virtual AddRef(),ULONG;
	declare virtual Release(),ULONG;
	int m_refcnt;
	QITAB *m_quitab; // not initialized in Unknown::Unknown()
}

class ClassFactory : Unknown
{
	declare ClassFactory();
	declare virtual CreateInstance(IUnknown *pUnkOuter, REFIID riid, void *ppvObject),HRESULT;
	declare virtual LockServer(BOOL fLock),HRESULT;
}

class CQueryContinue : Unknown
{
	declare CQueryContinue();
	declare virtual Release(),ULONG;
	declare virtual QueryContinue(),HRESULT;
	BOOL     *m_pRunning;
	IUnknown *m_commandtarget;
}

class OleCommandTarget : Unknown
{
	declare OleCommandTarget();
	declare virtual QueryStatus(GUID *pguidCmdGroup, ULONG cCmds, OLECMD *prgCmds, OLECMDTEXT *pCmdText),HRESULT;
	declare virtual Exec(GUID *pguidCmdGroup, DWORD nCmdID, DWORD nCmdExecOpt, VARIANT *pvaIn, VARIANT *pvaOut),HRESULT;
	// nCmdID=2: start, nCmdID=3: stop

	// StartService starts NotificationThread
	declare StartService();
	// StopService terminates NotificationThread
	declare StopService();
	// NotificationThread shows a balloon tooltip on each change in the event log and registry
	declare NotificationThread();
	// RegistryThread waits for registry changes, puts a log into log file and notifies NotificationThread about new records
	declare RegistryThread();
	// 
	declare ReadRegistryLogEntries();
	declare ReadRegistryLogEntry();
	//
	declare HandleRegistryKeyChange(HANDLE hEvent, HKEY key, LPWSTR pwszKey, LPVOID pRegContext);
	declare ReadEventLogEntries();
	declare ReadEventLogEntry(EVENTLOGRECORD *pevlr);
	// FormatMessageForEvent returns the complete event description. Use LocalFree to free the returned string.
	declare FormatMessageForEvent(EVENTLOGRECORD *pevlr, LPWSTR *ppv),BOOL;
	// helpers for registry
	declare OpenRegistryLog(HANDLE hEvent);
	declare CloseRegistryLog();
	// helpers for balloon
	declare CreateBalloon(IUserNotification *ppv),HRESULT;

	HANDLE m_hThread;
	HANDLE m_hEventLog;
	HANDLE m_hExitEvent;
	HICON  m_hIcon;
	CQueryContinue *m_iqc;
	BOOL   m_fRunning;
	// registry log. Initialize with OpenRegistryLog(), cleanup with CloseRegistryLog()
	HANDLE m_hRegistryLogWrite;
	HANDLE m_hRegistryLogRead;
	HANDLE m_hRegistryThread;
	HANDLE m_hRegistryLogEvent; // saved from OpenRegistryLog()
	LONG   m_nRegistryLogEntries; // number of entries to read from the log file
}

//extern _CLSID_EventLogNotifier as GUID;
